// file: $isip/class/pr/ProductionRuleTokenType/prtt_04.cc
// version: $Id: prtt_04.cc 10419 2006-02-03 21:51:48Z slee $

//isip include files
//
#include "ProductionRuleTokenType.h"

// method: write
//
// arguments:
//  Sof& sof: (input) sof file object
//  long tag: (input) sof object instance tag
//  const String& name: (input) sof object instance name
//
// return: boolean value indicating status
//
// this method has the object write itself to an Sof file
//
boolean ProductionRuleTokenType::write(Sof& sof_a, long tag_a,
			     const String& name_a) const {
  long obj_size = 0;

  // figure out size
  //
  if (sof_a.isText()) {

    //dynamic for text
    //
    obj_size = Sof::ANY_SIZE;
  }
  else {
    obj_size = sofSize();
  }

  // write object into sof index
  //
  if (!sof_a.put(name_a, tag_a, obj_size)) {
    return false;
  }
  
  // exit gracefully
  //
  return writeData(sof_a);
}

// method: writeData
//
// arguments:
//  Sof& sof: (input) sof file object
//  const String& pname: (input) parameter name
//
// return: boolean value indicating status
//
// this method has the object write itself to an Sof file.
//
boolean ProductionRuleTokenType::writeData(Sof& sof_a, const String& pname_a) const {

  //write a start string if necessary
  //
  sof_a.writeLabelPrefix(pname_a);
  
  TYPE_MAP.writeElementData(sof_a,  PARAM_TYPE, (ushort)type_d);

  // put an end string if necessary
  //
  sof_a.writeLabelSuffix(pname_a);
  
  // exit gracefully
  //  
  return true;
}
